/*
 * 
 * This file is part of the ANNMu project.
 * 
 * Copyright (c) 2021-2022 Adam Novak <annmproject@protonmail.com>
 *
 * This project is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This project is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this project. If not, see https://www.gnu.org/licenses/.
 *
 * You can be released from the requirements of the license by obtaining
 * a commercial license. Getting such a license is mandatory as soon as you
 * develop commercial activities involving the ANNMu source code without
 * disclosing the source code of your own applications.
 *
 */

#ifndef ANNMu_TRANSLATIONS_CS_HPP
#define ANNMu_TRANSLATIONS_CS_HPP

namespace annmu {

    namespace translations {

        namespace cs {
            
            static const char * const WORKING_HOURS = "Pracovní doba";
            static const char * const OPENING_HORUS = "Otevírací doba";

            static const char * const MONDAY = "Pondělí";
            static const char * const TUESDAY = "Úterý";
            static const char * const WEDNESDAY = "Středa";
            static const char * const THURSDAY = "Čtvrtek";
            static const char * const FRIDAY = "Pátek";
            static const char * const SATURDAY = "Sobota";
            static const char * const SUNDAY = "Neděle";

            static const char * const MON = "Po";
            static const char * const TUES = "Út";
            static const char * const WED = "St";
            static const char * const THUR = "Čt";
            static const char * const FRI = "Pá";
            static const char * const SAT = "So";
            static const char * const SUN = "Ne";

            static const char * const NAME = "Jméno";
            static const char * const SURNAME = "Příjmení";
            static const char * const ADDRESS = "Adresa";
            static const char * const CITY = "Obec";
            static const char * const STREET = "Ulice";
            static const char * const HOUSE_NUMBER = "Číslo popisné";
            static const char * const PHONE = "Telefon";
            static const char * const EMAIL = "E-mail";

            static const char * const SEND = "Odeslat";
            static const char * const BACK = "Zpět";
            static const char * const I_AGREE = "Souhlasím";
            static const char * const LOG_IN = "Přihlásit se";
            static const char * const LOG_OUT = "Odhlásit se";
            static const char * const REGISTER = "Registrovat se";
            static const char * const REGISTRATION = "Registrace";
            static const char * const SAVE = "Uložit";
            static const char * const NEXT = "Další";
            static const char * const READ_MORE = "Číst více";
            static const char * const MORE_INFO = "Více informací";
            static const char * const EDIT = "Upravit";
            static const char * const CREATE = "Vytvořit";
            static const char * const NEW = "Nový";

            static const char * const MENU = "Menu";
            static const char * const CONTACT = "Kontakt";
            static const char * const ABOUT_US = "O nás";
            static const char * const HOMEPAGE = "Hlavní strana";
            static const char * const BLOG = "Blog";
            static const char * const PRIVACY_POLICY = "Zásady ochrany osobních údajů";

            static const char * const CZECH = "Čeština";
            static const char * const ENGLISH = "Angličtina";
            static const char * const DEUTSCH = "Němčina";
            static const char * const POLAND = "Polština";
            static const char * const RUSSIAN = "Ruština";

        }

    }

}

#endif
