/*
 * 
 * This file is part of the ANNMu project.
 * 
 * Copyright (c) 2021-2022 Adam Novak <annmproject@protonmail.com>
 *
 * This project is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This project is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this project. If not, see https://www.gnu.org/licenses/.
 *
 * You can be released from the requirements of the license by obtaining
 * a commercial license. Getting such a license is mandatory as soon as you
 * develop commercial activities involving the ANNMu source code without
 * disclosing the source code of your own applications.
 *
 */

#ifndef ANNMu_TRANSLATIONS_EN_HPP
#define ANNMu_TRANSLATIONS_EN_HPP

namespace annmu {

    namespace translations {

        namespace en {
            
            static const char * const WORKING_HOURS = "Working hours";
            static const char * const OPENING_HORUS = "Opening hours";

            static const char * const MONDAY = "Monday";
            static const char * const TUESDAY = "Tuesday";
            static const char * const WEDNESDAY = "Wednesday";
            static const char * const THURSDAY = "Thursday";
            static const char * const FRIDAY = "Friday";
            static const char * const SATURDAY = "Saturday";
            static const char * const SUNDAY = "Sunday";

            static const char * const MON = "Mon";
            static const char * const TUES = "Tue";
            static const char * const WED = "Wed";
            static const char * const THUR = "Thur";
            static const char * const FRI = "Fri";
            static const char * const SAT = "Sat";
            static const char * const SUN = "Sun";

            static const char * const NAME = "Name";
            static const char * const SURNAME = "Surname";
            static const char * const ADDRESS = "Address";
            static const char * const CITY = "City";
            static const char * const STREET = "Street";
            static const char * const HOUSE_NUMBER = "House number";
            static const char * const PHONE = "PHONE";
            static const char * const EMAIL = "E-mail";

            static const char * const SEND = "Send";
            static const char * const BACK = "Back";
            static const char * const I_AGREE = "I agree";
            static const char * const LOG_IN = "Log in";
            static const char * const LOG_OUT = "Log out";
            static const char * const REGISTER = "Register";
            static const char * const REGISTRATION = "Registration";
            static const char * const SAVE = "Save";
            static const char * const NEXT = "Next";
            static const char * const READ_MORE = "Read more";
            static const char * const MORE_INFO = "More information";
            static const char * const EDIT = "Edit";
            static const char * const CREATE = "Create";
            static const char * const NEW = "New";

            static const char * const MENU = "Menu";
            static const char * const CONTACT = "Contact";
            static const char * const ABOUT_US = "About us";
            static const char * const HOMEPAGE = "Homepage";
            static const char * const BLOG = "Blog";
            static const char * const PRIVACY_POLICY = "Privacy policy";

            static const char * const CZECH = "Czech";
            static const char * const ENGLISH = "English";
            static const char * const DEUTSCH = "Deutsch";
            static const char * const POLAND = "Poland";
            static const char * const RUSSIAN = "Russian";

        }

    }

}

#endif
